/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the InteractionPatchable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InteractionPatchable{}

// InteractionPatchable struct for InteractionPatchable
type InteractionPatchable struct {
	Name *string `json:"name,omitempty"`
	LiveFrom *string `json:"live_from,omitempty"`
	LiveTo *string `json:"live_to,omitempty"`
}

// NewInteractionPatchable instantiates a new InteractionPatchable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInteractionPatchable() *InteractionPatchable {
	this := InteractionPatchable{}
	return &this
}

// NewInteractionPatchableWithDefaults instantiates a new InteractionPatchable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInteractionPatchableWithDefaults() *InteractionPatchable {
	this := InteractionPatchable{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *InteractionPatchable) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionPatchable) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *InteractionPatchable) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *InteractionPatchable) SetName(v string) {
	o.Name = &v
}

// GetLiveFrom returns the LiveFrom field value if set, zero value otherwise.
func (o *InteractionPatchable) GetLiveFrom() string {
	if o == nil || IsNil(o.LiveFrom) {
		var ret string
		return ret
	}
	return *o.LiveFrom
}

// GetLiveFromOk returns a tuple with the LiveFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionPatchable) GetLiveFromOk() (*string, bool) {
	if o == nil || IsNil(o.LiveFrom) {
		return nil, false
	}
	return o.LiveFrom, true
}

// HasLiveFrom returns a boolean if a field has been set.
func (o *InteractionPatchable) HasLiveFrom() bool {
	if o != nil && !IsNil(o.LiveFrom) {
		return true
	}

	return false
}

// SetLiveFrom gets a reference to the given string and assigns it to the LiveFrom field.
func (o *InteractionPatchable) SetLiveFrom(v string) {
	o.LiveFrom = &v
}

// GetLiveTo returns the LiveTo field value if set, zero value otherwise.
func (o *InteractionPatchable) GetLiveTo() string {
	if o == nil || IsNil(o.LiveTo) {
		var ret string
		return ret
	}
	return *o.LiveTo
}

// GetLiveToOk returns a tuple with the LiveTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionPatchable) GetLiveToOk() (*string, bool) {
	if o == nil || IsNil(o.LiveTo) {
		return nil, false
	}
	return o.LiveTo, true
}

// HasLiveTo returns a boolean if a field has been set.
func (o *InteractionPatchable) HasLiveTo() bool {
	if o != nil && !IsNil(o.LiveTo) {
		return true
	}

	return false
}

// SetLiveTo gets a reference to the given string and assigns it to the LiveTo field.
func (o *InteractionPatchable) SetLiveTo(v string) {
	o.LiveTo = &v
}

func (o InteractionPatchable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InteractionPatchable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.LiveFrom) {
		toSerialize["live_from"] = o.LiveFrom
	}
	if !IsNil(o.LiveTo) {
		toSerialize["live_to"] = o.LiveTo
	}
	return toSerialize, nil
}

type NullableInteractionPatchable struct {
	value *InteractionPatchable
	isSet bool
}

func (v NullableInteractionPatchable) Get() *InteractionPatchable {
	return v.value
}

func (v *NullableInteractionPatchable) Set(val *InteractionPatchable) {
	v.value = val
	v.isSet = true
}

func (v NullableInteractionPatchable) IsSet() bool {
	return v.isSet
}

func (v *NullableInteractionPatchable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInteractionPatchable(val *InteractionPatchable) *NullableInteractionPatchable {
	return &NullableInteractionPatchable{value: val, isSet: true}
}

func (v NullableInteractionPatchable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInteractionPatchable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


